//+------------------------------------------------------------------+
//|                                                 PipeTrader 20pip |
//|                                                www.forex-tsd.com |
//|                                                            mikep |
//+------------------------------------------------------------------+

#property copyright "System by PipeTrader, programmed by mikep"

//This version uses the following logic:
//For the first trade, the StepMA must cross AND the Force Index must exceed the threshold AT THE TIME OF THE STEPMA CROSS
//If the Force Index does not exceed the threshold, the EA will check the next candle.  If that candle has a FI greater than
//the threshold, then a trade will be opened.

//Additional entries after the MA Cross need the FI to cross over threshold and stay for two candles prior to entry
//-e.g. for a buy: candle 1 below 0.03, candle 2 above 0.03, candle 3 above 0.03, enter at opening of candle 4

//Exits are as per Post #  71 @ http://www.forex-tsd.com/suggestions-trading-systems/5847-my-simple-20-pips-8.html
//Because of this exit style I've disabled take profit

extern int MagicNumber = 0;
extern string ExpertName = "PipeTrader_SafeMode";
extern bool SignalMail = False;
extern bool EachTickMode = true;
extern double Lots = 1.0;
extern int Slippage = 3;
extern bool StopLossMode = True;
extern int StopLoss = 45;
extern bool TakeProfitMode = false;
extern int TakeProfit = 0;
extern bool TrailingStopMode = false;
extern int TrailingStop = 0;
extern double ForceSellThreshold = -0.03;
extern double ForceBuyThreshold = 0.03;
extern bool UseHourTrade = true;
extern int FromHourTrade = 2;
extern int ToHourTrade = 12;
extern int SignalTimeFrame = 30;

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

int BarCount;
int Current;
bool TickCheck = False;

static bool ITradedOnThisBar;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}

// Original code for exits
//
//  if ((StepMAUp12>=StepMADown22 && StepMAUp11<StepMADown21)||
//     (Force3>ForceBuyThreshold && Force2>ForceBuyThreshold &&
//      Force1>ForceBuyThreshold && Force3>Force2 && Force2>Force3)) Order = SIGNAL_CLOSEBUY;
//  if ((StepMAUp12<=StepMADown22 && StepMAUp11>StepMADown21)||
//     (Force3<ForceSellThreshold && Force2<ForceSellThreshold &&
//      Force1<ForceSellThreshold && Force3<Force2 && Force2<Force3)) Order = SIGNAL_CLOSESELL;
int CheckExitCondition(int cmd)
{
   double StepMAUp11, StepMADown21, StepMAUp12, StepMADown22;
   double Force1, Force2, Force3;
   
   bool rules1, rules2, rules3;
   bool rulef1, rulef2, rulef3, rulef4;
   
   rules1 = false;
   rules2 = false;
   rules3 = false;
   rulef1 = false;
   rulef2 = false;
   rulef3 = false;
   rulef4 = false;
   
   Force1=iForce(NULL,SignalTimeFrame,13,MODE_SMA,PRICE_CLOSE,1);

   switch (cmd)
   {
   case OP_BUY :
                 
//       if (Force3>ForceBuyThreshold && Force2>ForceBuyThreshold && Force1>ForceBuyThreshold && Force3>Force2 && Force2>Force3)) rulef1 = true ;
       if (Force1>ForceBuyThreshold) rulef1 = true;
       if (rulef1)
       {
          Force2=iForce(NULL,SignalTimeFrame,13,MODE_SMA,PRICE_CLOSE,2);
          if (Force2>ForceBuyThreshold) rulef2 = true;
          if (rulef2)
          {
             Force3=iForce(NULL,SignalTimeFrame,13,MODE_SMA,PRICE_CLOSE,3);
             if (Force3>ForceBuyThreshold) rulef3 = true;
             if (rulef3 && Force3>Force2 && Force2>Force1) rulef4 = true ;
          }
       }
       if (rulef4) return(SIGNAL_CLOSEBUY);
       
// Force did not exit so check StepMA
      
       StepMAUp12=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,0,2);
       StepMADown22=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,1,2);
       if (StepMAUp12>=StepMADown22) rules1 = true;
       if (rules1)
       {
           StepMAUp11=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,0,1);
           StepMADown21=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,1,1);
           if ( StepMAUp11<StepMADown21) rules2 = true;
       }
       if (rules1 && rules2) rules3 = true;
       if (rules3) return(SIGNAL_CLOSEBUY);
       break;
       
   case OP_SELL :
//        if (Force3<ForceSellThreshold && Force2<ForceSellThreshold && Force1<ForceSellThreshold && Force3<Force2 && Force2<Force3)) rulef1 = true;
        if (Force1<ForceSellThreshold) rulef1 = true;
        if (rulef1)
        {
           Force2=iForce(NULL,SignalTimeFrame,13,MODE_SMA,PRICE_CLOSE,2);
           if (Force2<ForceSellThreshold) rulef2 = true;
           if (rulef2)
           {
              Force3=iForce(NULL,SignalTimeFrame,13,MODE_SMA,PRICE_CLOSE,3);
              if (Force3<ForceSellThreshold) rulef3 = true;
              if (rulef3 && Force3<Force2 && Force2<Force1) rulef4 = true;
           }
        }
        if (rulef4) return(SIGNAL_CLOSESELL);
       
// Force did not exit so check StepMA
      
       StepMAUp12=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,0,2);
       StepMADown22=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,1,2);
       if (StepMAUp12<=StepMADown22) rules1 = true;
       if (rules1)
       {
           StepMAUp11=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,0,1);
           StepMADown21=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,1,1);
           if (StepMAUp11>StepMADown21) rules2 = true;
        }
        if (rules1 && rules2) rules3 = true;
        if (rules3) return(SIGNAL_CLOSESELL);
   }
   return (SIGNAL_NONE);
}

// Original code for entry
//      if ((StepMAUp12<=StepMADown22 && StepMAUp11>StepMADown21 && Force1>ForceBuyThreshold) ||
//
//         (StepMAUp13<=StepMADown23 && StepMAUp12>StepMADown22 && StepMAUp11>StepMADown21 &&
//          Force2<ForceBuyThreshold && Force1>ForceBuyThreshold) ||
//
//         (StepMAUp11>StepMADown21 &&
//           Force3<=ForceBuyThreshold && Force2>ForceBuyThreshold && Force1>ForceBuyThreshold)) Order = SIGNAL_BUY;
//
//      if ((StepMAUp12>=StepMADown22 && StepMAUp11<StepMADown21 && Force1<ForceSellThreshold) ||
//
//         (StepMAUp13>=StepMADown23 && StepMAUp12<StepMADown22 && StepMAUp11<StepMADown21 &&
//         Force2>ForceSellThreshold && Force1<ForceSellThreshold) ||
//
//         (StepMAUp11<StepMADown21 &&
//          Force3>=ForceSellThreshold && Force2<ForceSellThreshold && Force1<ForceSellThreshold)) Order = SIGNAL_SELL;

int CheckEntryCondition(int cmd)
{
      
   double StepMAUp11, StepMAUp12, StepMAUp13;
   double StepMADown21, StepMADown22, StepMADown23;
   double Force1, Force2, Force3;

   Force1=iForce(NULL,SignalTimeFrame,13,MODE_SMA,PRICE_CLOSE,1);
   switch(cmd)
   {
   case OP_BUY :
      if (Force1>ForceBuyThreshold)
      {
        StepMAUp11=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,0,1);
        StepMADown21=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,1,1);
        if (StepMAUp11>StepMADown21)
        {
           Force3=iForce(NULL,SignalTimeFrame,13,MODE_SMA,PRICE_CLOSE,3);
           Force2=iForce(NULL,SignalTimeFrame,13,MODE_SMA,PRICE_CLOSE,2);
           if (Force3<=ForceBuyThreshold && Force2>ForceBuyThreshold) return(SIGNAL_BUY);
           
           StepMAUp12=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,0,2);
           StepMADown22=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,1,2);
           if (StepMAUp12<=StepMADown22) return(SIGNAL_BUY);
           
           if (Force2<ForceBuyThreshold)
           {
              StepMAUp13=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,0,3);
              StepMADown23=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,1,3);           
              if (StepMAUp13<=StepMADown23) return(SIGNAL_BUY);
           }
           
           
        }
      }
      break;
   case OP_SELL :
      if (Force1<ForceSellThreshold)
      {
        StepMAUp11=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,0,1);
        StepMADown21=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,1,1);
        if (StepMAUp11<StepMADown21)
        {
           Force3=iForce(NULL,SignalTimeFrame,13,MODE_SMA,PRICE_CLOSE,3);
           Force2=iForce(NULL,SignalTimeFrame,13,MODE_SMA,PRICE_CLOSE,2);
           if (Force3>=ForceSellThreshold && Force2<ForceSellThreshold) return(SIGNAL_SELL);
           
           StepMAUp12=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,0,2);
           StepMADown22=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,1,2);
           if (StepMAUp12>=StepMADown22) return(SIGNAL_SELL);
           
           if (Force2>ForceSellThreshold)
           {
              StepMAUp13=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,0,3);
              StepMADown23=iCustom(NULL,SignalTimeFrame,"N_StepMA_1_Email",7,1,0,500,false,1,3);           
              if (StepMAUp13>=StepMADown23) return(SIGNAL_SELL);
           }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+
   return(SIGNAL_NONE);
   
}

bool HandleOpenPositions()
{

   bool myIsTrade = False;
   int Order = SIGNAL_NONE;
   int Total;

   Total = OrdersTotal();
   for (int i = Total - 1; i >=0; i--){
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol()) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      myIsTrade = True;
      if(ITradedOnThisBar != Bars){
         if(OrderType() == OP_BUY)
         {
            //Close
            if ( (EachTickMode && !TickCheck) || ( !EachTickMode && (Bars != BarCount) ) ){
              Order = CheckExitCondition(OP_BUY);
              if (Order == SIGNAL_CLOSEBUY){
                OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
                if (!EachTickMode) BarCount = Bars;
                myIsTrade = False;
                continue;
              }
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
         if (OrderType() == OP_SELL){
            //Close

            if ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))) {
              Order = CheckExitCondition(OP_SELL);
              if (Order == SIGNAL_CLOSESELL) {
                 OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
                 if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
                 if (!EachTickMode) BarCount = Bars;
                 myIsTrade = False;
                 continue;
              }
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }
   return (myIsTrade);

}

void OpenBuyOrder()
{

   int Ticket;
   double StopLossLevel, TakeProfitLevel;
         
   if (StopLossMode) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
   if (TakeProfitMode) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

   Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, ExpertName, MagicNumber, 0, DodgerBlue);
   ITradedOnThisBar = Bars;
   if(Ticket > 0) {
      if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				   Print("BUY order opened : ", OrderOpenPrice());
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
		} else {
				   Print("Error opening BUY order : ", GetLastError());
		}
   }

}

void OpenSellOrder()
{         

   int Ticket;
   double StopLossLevel, TakeProfitLevel;
   
   if (StopLossMode) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
   if (TakeProfitMode) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

   Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, ExpertName, MagicNumber, 0, DeepPink);
   ITradedOnThisBar = Bars;
   if(Ticket > 0) {
      if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				   Print("SELL order opened : ", OrderOpenPrice());
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
		} else {
				   Print("Error opening SELL order : ", GetLastError());
		}
   }

}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() 
{
   int Order = SIGNAL_NONE;
   bool IsTrade = False;

   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Order = SIGNAL_NONE;

   //Check position
   IsTrade = HandleOpenPositions();
   
  if(ITradedOnThisBar != Bars){
    if(!IsTrade) {
         //Check free margin
       if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
       }
// Moved time check to here so that the modify and exit logic would run outside of trading hours

       if (UseHourTrade){
         if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
           Comment("Time for trade has not come else!");
           return(0);
         }
       }

   //Buy
       Order = CheckEntryCondition(OP_BUY);
       if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
         OpenBuyOrder();
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
       }
    }

    if(!IsTrade) {
         //Check free margin
       if (AccountFreeMargin() < (1000 * Lots)) {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);
       }

// Moved time check to here so that the modify and exit logic would run outside of trading hours

       if (UseHourTrade){
         if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
            Comment("Time for trade has not come else!");
            return(0);
         }
       }

   //Sell
       Order = CheckEntryCondition(OP_SELL);
       if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
         OpenSellOrder();
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
       }
    }
   }
   if (!EachTickMode) BarCount = Bars;

   return(0);
}
//+------------------------------------------------------------------+